]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
x86/speculation/mmio: Reuse SRBDS mitigation for SBDS
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
c39013ee 41 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
42}
43
a8cccdd9
ST
44# Generate a linker script to ensure correct ordering of initcalls.
45gen_initcalls()
46{
47 info GEN .tmp_initcalls.lds
48
49 ${PYTHON} ${srctree}/scripts/jobserver-exec \
50 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
51 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
52 > .tmp_initcalls.lds
53}
54
38e89184
ST
55# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
56# .tmp_symversions.lds
57gen_symversions()
58{
59 info GEN .tmp_symversions.lds
60 rm -f .tmp_symversions.lds
61
62 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
63 if [ -f ${o}.symversions ]; then
64 cat ${o}.symversions >> .tmp_symversions.lds
65 fi
66 done
67}
68
1f2bfbd0
SR
69# Link of vmlinux.o used for section mismatch analysis
70# ${1} output file
71modpost_link()
72{
a5967db9 73 local objects
38e89184 74 local lds=""
a5967db9 75
6358d6e8 76 objects="--whole-archive \
d151e971 77 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
78 --no-whole-archive \
79 --start-group \
80 ${KBUILD_VMLINUX_LIBS} \
81 --end-group"
82
dc5723b0 83 if [ -n "${CONFIG_LTO_CLANG}" ]; then
a8cccdd9
ST
84 gen_initcalls
85 lds="-T .tmp_initcalls.lds"
86
38e89184
ST
87 if [ -n "${CONFIG_MODVERSIONS}" ]; then
88 gen_symversions
89 lds="${lds} -T .tmp_symversions.lds"
90 fi
91
dc5723b0
ST
92 # This might take a while, so indicate that we're doing
93 # an LTO link
94 info LTO ${1}
95 else
96 info LD ${1}
97 fi
98
38e89184 99 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
100}
101
6804c1af
PZ
102objtool_link()
103{
b1a1a1a0 104 local objtoolcmd;
6804c1af
PZ
105 local objtoolopt;
106
b1a1a1a0
ST
107 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
108 # Don't perform vmlinux validation unless explicitly requested,
109 # but run objtool on vmlinux.o now that we have an object file.
110 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
111 objtoolcmd="orc generate"
112 fi
113
114 objtoolopt="${objtoolopt} --duplicate"
115
116 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
117 objtoolopt="${objtoolopt} --mcount"
118 fi
119 fi
120
6804c1af 121 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
b1a1a1a0
ST
122 objtoolopt="${objtoolopt} --noinstr"
123 fi
124
125 if [ -n "${objtoolopt}" ]; then
126 if [ -z "${objtoolcmd}" ]; then
127 objtoolcmd="check"
128 fi
129 objtoolopt="${objtoolopt} --vmlinux"
6804c1af
PZ
130 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
131 objtoolopt="${objtoolopt} --no-fp"
132 fi
b1a1a1a0 133 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
6804c1af
PZ
134 objtoolopt="${objtoolopt} --no-unreachable"
135 fi
136 if [ -n "${CONFIG_RETPOLINE}" ]; then
137 objtoolopt="${objtoolopt} --retpoline"
138 fi
139 if [ -n "${CONFIG_X86_SMAP}" ]; then
140 objtoolopt="${objtoolopt} --uaccess"
141 fi
142 info OBJTOOL ${1}
b1a1a1a0 143 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
144 fi
145}
146
1f2bfbd0 147# Link of vmlinux
341dfcf8 148# ${1} - output file
618916a4 149# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
150vmlinux_link()
151{
618916a4 152 local output=${1}
8f130512
MY
153 local objs
154 local libs
5df77ad6
MY
155 local ld
156 local ldflags
157 local ldlibs
1f2bfbd0 158
d7b0827f
LT
159 info LD ${output}
160
618916a4
AN
161 # skip output file argument
162 shift
163
8f130512
MY
164 if [ -n "${CONFIG_LTO_CLANG}" ]; then
165 # Use vmlinux.o instead of performing the slow LTO link again.
166 objs=vmlinux.o
167 libs=
168 else
169 objs="${KBUILD_VMLINUX_OBJS}"
170 libs="${KBUILD_VMLINUX_LIBS}"
171 fi
172
5df77ad6
MY
173 if [ "${SRCARCH}" = "um" ]; then
174 wl=-Wl,
175 ld="${CC}"
176 ldflags="${CFLAGS_vmlinux}"
177 ldlibs="-lutil -lrt -lpthread"
178 else
179 wl=
180 ld="${LD}"
181 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
182 ldlibs=
183 fi
184
185 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
186
af73d78b
KC
187 # The kallsyms linking does not need debug symbols included.
188 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
5df77ad6 189 ldflags="${ldflags} ${wl}--strip-debug"
af73d78b
KC
190 fi
191
5cc12472 192 if [ -n "${CONFIG_VMLINUX_MAP}" ]; then
5df77ad6 193 ldflags="${ldflags} ${wl}-Map=${output}.map"
5cc12472
RV
194 fi
195
5df77ad6
MY
196 ${ld} ${ldflags} -o ${output} \
197 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
198 ${wl}--start-group ${libs} ${wl}--end-group \
199 $@ ${ldlibs}
1f2bfbd0
SR
200}
201
e83b9f55 202# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
203# ${1} - vmlinux image
204# ${2} - file to dump raw BTF data into
e83b9f55
AN
205gen_btf()
206{
341dfcf8 207 local pahole_ver
e83b9f55 208
581b31c3 209 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 210 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 211 return 1
581b31c3
AN
212 fi
213
e83b9f55 214 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
215 if [ "${pahole_ver}" -lt "116" ]; then
216 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 217 return 1
e83b9f55
AN
218 fi
219
341dfcf8 220 vmlinux_link ${1}
af73d78b
KC
221
222 info "BTF" ${2}
3f20d2f9 223 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
341dfcf8 224
90ceddcb
FS
225 # Create ${2} which contains just .BTF section but no symbols. Add
226 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
227 # deletes all symbols including __start_BTF and __stop_BTF, which will
228 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
229 # objcopy warnings: "empty loadable segment detected at ..."
230 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
231 --strip-all ${1} ${2} 2>/dev/null
232 # Change e_type to ET_REL so that it can be used to link final vmlinux.
233 # Unlike GNU ld, lld does not allow an ET_EXEC input.
234 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 235}
1f2bfbd0 236
08beb669 237# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
238kallsyms()
239{
1f2bfbd0
SR
240 local kallsymopt;
241
242 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 243 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
244 fi
245
4d5d5664 246 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
247 kallsymopt="${kallsymopt} --absolute-percpu"
248 fi
249
2213e9a6
AB
250 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
251 kallsymopt="${kallsymopt} --base-relative"
252 fi
253
08beb669
MY
254 info KSYMS ${2}
255 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
256}
257
8959e392
KC
258# Perform one step in kallsyms generation, including temporary linking of
259# vmlinux.
260kallsyms_step()
261{
262 kallsymso_prev=${kallsymso}
af73d78b
KC
263 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
264 kallsymso=${kallsyms_vmlinux}.o
08beb669 265 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 266
d7b0827f 267 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
268 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
269
270 info AS ${kallsyms_S}
271 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
272 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
273 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
274}
275
1f2bfbd0
SR
276# Create map file with all symbols from ${1}
277# See mksymap for additional details
278mksysmap()
279{
280 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
281}
282
10916706 283sorttable()
1347a2ce 284{
10916706 285 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
286}
287
1f2bfbd0 288# Delete output files in case of error
1f2bfbd0
SR
289cleanup()
290{
341dfcf8 291 rm -f .btf.*
1f2bfbd0 292 rm -f .tmp_System.map
a8cccdd9 293 rm -f .tmp_initcalls.lds
38e89184 294 rm -f .tmp_symversions.lds
1f2bfbd0
SR
295 rm -f .tmp_vmlinux*
296 rm -f System.map
297 rm -f vmlinux
5cc12472 298 rm -f vmlinux.map
1f2bfbd0 299 rm -f vmlinux.o
0b956e20 300 rm -f .vmlinux.d
1f2bfbd0
SR
301}
302
1f2bfbd0
SR
303# Use "make V=1" to debug this script
304case "${KBUILD_VERBOSE}" in
305*1*)
306 set -x
307 ;;
308esac
309
310if [ "$1" = "clean" ]; then
311 cleanup
312 exit 0
313fi
314
315# We need access to CONFIG_ symbols
94cf8acc 316. include/config/auto.conf
1f2bfbd0 317
1f2bfbd0
SR
318# Update version
319info GEN .version
278ae604
MY
320if [ -r .version ]; then
321 VERSION=$(expr 0$(cat .version) + 1)
322 echo $VERSION > .version
1f2bfbd0 323else
278ae604
MY
324 rm -f .version
325 echo 1 > .version
1f2bfbd0
SR
326fi;
327
328# final build of init/
083bc0e1 329${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 330
abac4c89 331#link vmlinux.o
abac4c89 332modpost_link vmlinux.o
6804c1af 333objtool_link vmlinux.o
abac4c89
NP
334
335# modpost vmlinux.o to check for section mismatches
a721588d 336${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 337
898490c0
AG
338info MODINFO modules.builtin.modinfo
339${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
340info GEN modules.builtin
341# The second line aids cases where multiple modules share the same object.
342tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
343 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 344
7fd78568 345btf_vmlinux_bin_o=""
341dfcf8 346if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
347 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
348 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
349 echo >&2 "Failed to generate BTF for vmlinux"
350 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
351 exit 1
341dfcf8
AN
352 fi
353fi
354
1f2bfbd0 355kallsymso=""
8959e392 356kallsymso_prev=""
1f2bfbd0
SR
357kallsyms_vmlinux=""
358if [ -n "${CONFIG_KALLSYMS}" ]; then
359
360 # kallsyms support
361 # Generate section listing all symbols and add it into vmlinux
362 # It's a three step process:
363 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
364 # but __kallsyms is empty.
365 # Running kallsyms on that gives us .tmp_kallsyms1.o with
366 # the right size
367 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
368 # the right size, but due to the added section, some
369 # addresses have shifted.
370 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
371 # 3) That link may have expanded the kernel image enough that
372 # more linker branch stubs / trampolines had to be added, which
373 # introduces new names, which further expands kallsyms. Do another
374 # pass if that is the case. In theory it's possible this results
375 # in even more stubs, but unlikely.
376 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
377 # other bugs.
378 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
379 #
380 # a) Verify that the System.map from vmlinux matches the map from
381 # ${kallsymso}.
382
8959e392
KC
383 kallsyms_step 1
384 kallsyms_step 2
1f2bfbd0 385
7e2b37c9 386 # step 3
8959e392
KC
387 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
388 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
389
390 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 391 kallsyms_step 3
1f2bfbd0
SR
392 fi
393fi
394
d7b0827f 395vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 396
c9a0f3b8 397# fill in BTF IDs
017dab34
JO
398if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
399 info BTFIDS vmlinux
400 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
401fi
402
10916706
SZ
403if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
404 info SORTTAB vmlinux
f14bf6a3
SZ
405 if ! sorttable vmlinux; then
406 echo >&2 Failed to sort kernel tables
407 exit 1
408 fi
1347a2ce
LT
409fi
410
1f2bfbd0
SR
411info SYSMAP System.map
412mksysmap vmlinux System.map
413
414# step a (see comment above)
415if [ -n "${CONFIG_KALLSYMS}" ]; then
416 mksysmap ${kallsyms_vmlinux} .tmp_System.map
417
418 if ! cmp -s System.map .tmp_System.map; then
5369f550 419 echo >&2 Inconsistent kallsyms data
367e43c5 420 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
421 exit 1
422 fi
423fi
0b956e20
RV
424
425# For fixdep
426echo "vmlinux: $0" > .vmlinux.d